/*-
 * Copyright (C)2000, 2001, 2002 @BABOLO http://www.links.ru/~babolo/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: getCGIparm.h,v 1.5 2003/11/04 08:37:39 babolo Exp $
 */

#define gCGI_DOER    0x001   /* Error indicate when parameter not found */
#define gCGI_MATC    0x002   /* Non-matching result is error            */
#define gCGI_NONL    0x004   /* Empty result string is error            */
#define gCGI_ERRMASK 0x007
#define gCGI_TEXT    0x010   /* errform is text                         */
#define gCGI_FILE    0x020   /* errform is filename with text           */
#define gCGI_FORM    0x040   /* errform is filename of errors formats   */
#define gCGI_OUTMASK 0x070
#define gCGI_NOCR 0x000100   /* Delete CR on output                     */
#define gCGI_NOLF 0x000200   /* Delete LF on output                     */
#define gCGI_OTST 0x000400   /* No output - test only                   */
#define gCGI_ZERO 0x000800   /* Empty parameter will be substituted     */
#define gCGI_HOVR 0x001000   /* Hack ON - use SERVER_PROTOCOL           */
#define gCGI_RTRY 0x002000   /* Retry if empty parameter found          */
#define gCGI_OPEN 0x004000   /* tofind on pass4 has * at end            */
#define gCGI_VERB 0x010000   /* Verbose                                 */
#define gCGI_VERM 0x020000   /* Verbose more                            */

struct getCGIparmpatterns {
    u_char *name;
    int namelen;
    const int (*test_proc)(const u_char *pattern, const u_char *query);
};

struct getCGIparmquotens {
    u_char *name;
    int namelen;
    const int (*test_proc)(const u_char *pattern, const u_char *query, u_char **result);
};

extern const struct getCGIparmpatterns getCGIparmpatterns[];
extern const struct getCGIparmquotens getCGIparmquotens[];

int getCGIparmpass1 __P((u_int32_t, const u_char **, const u_char *, u_char *));
int getCGIparmpass2 __P((u_int32_t, const u_char *, const u_char *));
int getCGIparmpass3 __P((u_int32_t, const u_char *, u_char **));
void getCGIparmpass4 __P((u_int32_t, const u_char *, const u_char *, const u_char *, FILE *));
